// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from smacc2_msgs:msg/SmaccContainerInitialStatusCmd.idl
// generated code does not contain a copyright notice

#ifndef SMACC2_MSGS__MSG__DETAIL__SMACC_CONTAINER_INITIAL_STATUS_CMD__TRAITS_HPP_
#define SMACC2_MSGS__MSG__DETAIL__SMACC_CONTAINER_INITIAL_STATUS_CMD__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "smacc2_msgs/msg/detail/smacc_container_initial_status_cmd__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace smacc2_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const SmaccContainerInitialStatusCmd & msg,
  std::ostream & out)
{
  out << "{";
  // member: path
  {
    out << "path: ";
    rosidl_generator_traits::value_to_yaml(msg.path, out);
    out << ", ";
  }

  // member: initial_states
  {
    if (msg.initial_states.size() == 0) {
      out << "initial_states: []";
    } else {
      out << "initial_states: [";
      size_t pending_items = msg.initial_states.size();
      for (auto item : msg.initial_states) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: local_data
  {
    out << "local_data: ";
    rosidl_generator_traits::value_to_yaml(msg.local_data, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SmaccContainerInitialStatusCmd & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: path
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "path: ";
    rosidl_generator_traits::value_to_yaml(msg.path, out);
    out << "\n";
  }

  // member: initial_states
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.initial_states.size() == 0) {
      out << "initial_states: []\n";
    } else {
      out << "initial_states:\n";
      for (auto item : msg.initial_states) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: local_data
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "local_data: ";
    rosidl_generator_traits::value_to_yaml(msg.local_data, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SmaccContainerInitialStatusCmd & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace smacc2_msgs

namespace rosidl_generator_traits
{

[[deprecated("use smacc2_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const smacc2_msgs::msg::SmaccContainerInitialStatusCmd & msg,
  std::ostream & out, size_t indentation = 0)
{
  smacc2_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use smacc2_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const smacc2_msgs::msg::SmaccContainerInitialStatusCmd & msg)
{
  return smacc2_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<smacc2_msgs::msg::SmaccContainerInitialStatusCmd>()
{
  return "smacc2_msgs::msg::SmaccContainerInitialStatusCmd";
}

template<>
inline const char * name<smacc2_msgs::msg::SmaccContainerInitialStatusCmd>()
{
  return "smacc2_msgs/msg/SmaccContainerInitialStatusCmd";
}

template<>
struct has_fixed_size<smacc2_msgs::msg::SmaccContainerInitialStatusCmd>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<smacc2_msgs::msg::SmaccContainerInitialStatusCmd>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<smacc2_msgs::msg::SmaccContainerInitialStatusCmd>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // SMACC2_MSGS__MSG__DETAIL__SMACC_CONTAINER_INITIAL_STATUS_CMD__TRAITS_HPP_
