// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from smacc2_msgs:msg/SmaccContainerInitialStatusCmd.idl
// generated code does not contain a copyright notice

#ifndef SMACC2_MSGS__MSG__DETAIL__SMACC_CONTAINER_INITIAL_STATUS_CMD__STRUCT_H_
#define SMACC2_MSGS__MSG__DETAIL__SMACC_CONTAINER_INITIAL_STATUS_CMD__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'path'
// Member 'initial_states'
// Member 'local_data'
#include "rosidl_runtime_c/string.h"

/// Struct defined in msg/SmaccContainerInitialStatusCmd in the package smacc2_msgs.
/**
  * The path to the node in the server
 */
typedef struct smacc2_msgs__msg__SmaccContainerInitialStatusCmd
{
  rosidl_runtime_c__String path;
  /// The desired initial state(s)
  rosidl_runtime_c__String__Sequence initial_states;
  /// Initial values for the local user data of the state machine
  /// A pickled user data structure
  /// i.e. the UserData's internal dictionary
  rosidl_runtime_c__String local_data;
} smacc2_msgs__msg__SmaccContainerInitialStatusCmd;

// Struct for a sequence of smacc2_msgs__msg__SmaccContainerInitialStatusCmd.
typedef struct smacc2_msgs__msg__SmaccContainerInitialStatusCmd__Sequence
{
  smacc2_msgs__msg__SmaccContainerInitialStatusCmd * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} smacc2_msgs__msg__SmaccContainerInitialStatusCmd__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // SMACC2_MSGS__MSG__DETAIL__SMACC_CONTAINER_INITIAL_STATUS_CMD__STRUCT_H_
