// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from smacc2_msgs:msg/SmaccContainerStructure.idl
// generated code does not contain a copyright notice

#ifndef SMACC2_MSGS__MSG__DETAIL__SMACC_CONTAINER_STRUCTURE__FUNCTIONS_H_
#define SMACC2_MSGS__MSG__DETAIL__SMACC_CONTAINER_STRUCTURE__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/action_type_support_struct.h"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_runtime_c/service_type_support_struct.h"
#include "rosidl_runtime_c/type_description/type_description__struct.h"
#include "rosidl_runtime_c/type_description/type_source__struct.h"
#include "rosidl_runtime_c/type_hash.h"
#include "rosidl_runtime_c/visibility_control.h"
#include "smacc2_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "smacc2_msgs/msg/detail/smacc_container_structure__struct.h"

/// Initialize msg/SmaccContainerStructure message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * smacc2_msgs__msg__SmaccContainerStructure
 * )) before or use
 * smacc2_msgs__msg__SmaccContainerStructure__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_smacc2_msgs
bool
smacc2_msgs__msg__SmaccContainerStructure__init(smacc2_msgs__msg__SmaccContainerStructure * msg);

/// Finalize msg/SmaccContainerStructure message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_smacc2_msgs
void
smacc2_msgs__msg__SmaccContainerStructure__fini(smacc2_msgs__msg__SmaccContainerStructure * msg);

/// Create msg/SmaccContainerStructure message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * smacc2_msgs__msg__SmaccContainerStructure__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_smacc2_msgs
smacc2_msgs__msg__SmaccContainerStructure *
smacc2_msgs__msg__SmaccContainerStructure__create();

/// Destroy msg/SmaccContainerStructure message.
/**
 * It calls
 * smacc2_msgs__msg__SmaccContainerStructure__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_smacc2_msgs
void
smacc2_msgs__msg__SmaccContainerStructure__destroy(smacc2_msgs__msg__SmaccContainerStructure * msg);

/// Check for msg/SmaccContainerStructure message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_smacc2_msgs
bool
smacc2_msgs__msg__SmaccContainerStructure__are_equal(const smacc2_msgs__msg__SmaccContainerStructure * lhs, const smacc2_msgs__msg__SmaccContainerStructure * rhs);

/// Copy a msg/SmaccContainerStructure message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_smacc2_msgs
bool
smacc2_msgs__msg__SmaccContainerStructure__copy(
  const smacc2_msgs__msg__SmaccContainerStructure * input,
  smacc2_msgs__msg__SmaccContainerStructure * output);

/// Retrieve pointer to the hash of the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_smacc2_msgs
const rosidl_type_hash_t *
smacc2_msgs__msg__SmaccContainerStructure__get_type_hash(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_smacc2_msgs
const rosidl_runtime_c__type_description__TypeDescription *
smacc2_msgs__msg__SmaccContainerStructure__get_type_description(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the single raw source text that defined this type.
ROSIDL_GENERATOR_C_PUBLIC_smacc2_msgs
const rosidl_runtime_c__type_description__TypeSource *
smacc2_msgs__msg__SmaccContainerStructure__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the recursive raw sources that defined the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_smacc2_msgs
const rosidl_runtime_c__type_description__TypeSource__Sequence *
smacc2_msgs__msg__SmaccContainerStructure__get_type_description_sources(
  const rosidl_message_type_support_t * type_support);

/// Initialize array of msg/SmaccContainerStructure messages.
/**
 * It allocates the memory for the number of elements and calls
 * smacc2_msgs__msg__SmaccContainerStructure__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_smacc2_msgs
bool
smacc2_msgs__msg__SmaccContainerStructure__Sequence__init(smacc2_msgs__msg__SmaccContainerStructure__Sequence * array, size_t size);

/// Finalize array of msg/SmaccContainerStructure messages.
/**
 * It calls
 * smacc2_msgs__msg__SmaccContainerStructure__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_smacc2_msgs
void
smacc2_msgs__msg__SmaccContainerStructure__Sequence__fini(smacc2_msgs__msg__SmaccContainerStructure__Sequence * array);

/// Create array of msg/SmaccContainerStructure messages.
/**
 * It allocates the memory for the array and calls
 * smacc2_msgs__msg__SmaccContainerStructure__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_smacc2_msgs
smacc2_msgs__msg__SmaccContainerStructure__Sequence *
smacc2_msgs__msg__SmaccContainerStructure__Sequence__create(size_t size);

/// Destroy array of msg/SmaccContainerStructure messages.
/**
 * It calls
 * smacc2_msgs__msg__SmaccContainerStructure__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_smacc2_msgs
void
smacc2_msgs__msg__SmaccContainerStructure__Sequence__destroy(smacc2_msgs__msg__SmaccContainerStructure__Sequence * array);

/// Check for msg/SmaccContainerStructure message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_smacc2_msgs
bool
smacc2_msgs__msg__SmaccContainerStructure__Sequence__are_equal(const smacc2_msgs__msg__SmaccContainerStructure__Sequence * lhs, const smacc2_msgs__msg__SmaccContainerStructure__Sequence * rhs);

/// Copy an array of msg/SmaccContainerStructure messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_smacc2_msgs
bool
smacc2_msgs__msg__SmaccContainerStructure__Sequence__copy(
  const smacc2_msgs__msg__SmaccContainerStructure__Sequence * input,
  smacc2_msgs__msg__SmaccContainerStructure__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // SMACC2_MSGS__MSG__DETAIL__SMACC_CONTAINER_STRUCTURE__FUNCTIONS_H_
