// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from smacc2_msgs:msg/SmaccState.idl
// generated code does not contain a copyright notice
#include "smacc2_msgs/msg/detail/smacc_state__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `name`
// Member `children_states`
#include "rosidl_runtime_c/string_functions.h"
// Member `transitions`
#include "smacc2_msgs/msg/detail/smacc_transition__functions.h"
// Member `orthogonals`
#include "smacc2_msgs/msg/detail/smacc_orthogonal__functions.h"
// Member `state_reactors`
#include "smacc2_msgs/msg/detail/smacc_state_reactor__functions.h"
// Member `event_generators`
#include "smacc2_msgs/msg/detail/smacc_event_generator__functions.h"

bool
smacc2_msgs__msg__SmaccState__init(smacc2_msgs__msg__SmaccState * msg)
{
  if (!msg) {
    return false;
  }
  // index
  // name
  if (!rosidl_runtime_c__String__init(&msg->name)) {
    smacc2_msgs__msg__SmaccState__fini(msg);
    return false;
  }
  // children_states
  if (!rosidl_runtime_c__String__Sequence__init(&msg->children_states, 0)) {
    smacc2_msgs__msg__SmaccState__fini(msg);
    return false;
  }
  // level
  // transitions
  if (!smacc2_msgs__msg__SmaccTransition__Sequence__init(&msg->transitions, 0)) {
    smacc2_msgs__msg__SmaccState__fini(msg);
    return false;
  }
  // orthogonals
  if (!smacc2_msgs__msg__SmaccOrthogonal__Sequence__init(&msg->orthogonals, 0)) {
    smacc2_msgs__msg__SmaccState__fini(msg);
    return false;
  }
  // state_reactors
  if (!smacc2_msgs__msg__SmaccStateReactor__Sequence__init(&msg->state_reactors, 0)) {
    smacc2_msgs__msg__SmaccState__fini(msg);
    return false;
  }
  // event_generators
  if (!smacc2_msgs__msg__SmaccEventGenerator__Sequence__init(&msg->event_generators, 0)) {
    smacc2_msgs__msg__SmaccState__fini(msg);
    return false;
  }
  return true;
}

void
smacc2_msgs__msg__SmaccState__fini(smacc2_msgs__msg__SmaccState * msg)
{
  if (!msg) {
    return;
  }
  // index
  // name
  rosidl_runtime_c__String__fini(&msg->name);
  // children_states
  rosidl_runtime_c__String__Sequence__fini(&msg->children_states);
  // level
  // transitions
  smacc2_msgs__msg__SmaccTransition__Sequence__fini(&msg->transitions);
  // orthogonals
  smacc2_msgs__msg__SmaccOrthogonal__Sequence__fini(&msg->orthogonals);
  // state_reactors
  smacc2_msgs__msg__SmaccStateReactor__Sequence__fini(&msg->state_reactors);
  // event_generators
  smacc2_msgs__msg__SmaccEventGenerator__Sequence__fini(&msg->event_generators);
}

bool
smacc2_msgs__msg__SmaccState__are_equal(const smacc2_msgs__msg__SmaccState * lhs, const smacc2_msgs__msg__SmaccState * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // index
  if (lhs->index != rhs->index) {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->name), &(rhs->name)))
  {
    return false;
  }
  // children_states
  if (!rosidl_runtime_c__String__Sequence__are_equal(
      &(lhs->children_states), &(rhs->children_states)))
  {
    return false;
  }
  // level
  if (lhs->level != rhs->level) {
    return false;
  }
  // transitions
  if (!smacc2_msgs__msg__SmaccTransition__Sequence__are_equal(
      &(lhs->transitions), &(rhs->transitions)))
  {
    return false;
  }
  // orthogonals
  if (!smacc2_msgs__msg__SmaccOrthogonal__Sequence__are_equal(
      &(lhs->orthogonals), &(rhs->orthogonals)))
  {
    return false;
  }
  // state_reactors
  if (!smacc2_msgs__msg__SmaccStateReactor__Sequence__are_equal(
      &(lhs->state_reactors), &(rhs->state_reactors)))
  {
    return false;
  }
  // event_generators
  if (!smacc2_msgs__msg__SmaccEventGenerator__Sequence__are_equal(
      &(lhs->event_generators), &(rhs->event_generators)))
  {
    return false;
  }
  return true;
}

bool
smacc2_msgs__msg__SmaccState__copy(
  const smacc2_msgs__msg__SmaccState * input,
  smacc2_msgs__msg__SmaccState * output)
{
  if (!input || !output) {
    return false;
  }
  // index
  output->index = input->index;
  // name
  if (!rosidl_runtime_c__String__copy(
      &(input->name), &(output->name)))
  {
    return false;
  }
  // children_states
  if (!rosidl_runtime_c__String__Sequence__copy(
      &(input->children_states), &(output->children_states)))
  {
    return false;
  }
  // level
  output->level = input->level;
  // transitions
  if (!smacc2_msgs__msg__SmaccTransition__Sequence__copy(
      &(input->transitions), &(output->transitions)))
  {
    return false;
  }
  // orthogonals
  if (!smacc2_msgs__msg__SmaccOrthogonal__Sequence__copy(
      &(input->orthogonals), &(output->orthogonals)))
  {
    return false;
  }
  // state_reactors
  if (!smacc2_msgs__msg__SmaccStateReactor__Sequence__copy(
      &(input->state_reactors), &(output->state_reactors)))
  {
    return false;
  }
  // event_generators
  if (!smacc2_msgs__msg__SmaccEventGenerator__Sequence__copy(
      &(input->event_generators), &(output->event_generators)))
  {
    return false;
  }
  return true;
}

smacc2_msgs__msg__SmaccState *
smacc2_msgs__msg__SmaccState__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  smacc2_msgs__msg__SmaccState * msg = (smacc2_msgs__msg__SmaccState *)allocator.allocate(sizeof(smacc2_msgs__msg__SmaccState), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(smacc2_msgs__msg__SmaccState));
  bool success = smacc2_msgs__msg__SmaccState__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
smacc2_msgs__msg__SmaccState__destroy(smacc2_msgs__msg__SmaccState * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    smacc2_msgs__msg__SmaccState__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
smacc2_msgs__msg__SmaccState__Sequence__init(smacc2_msgs__msg__SmaccState__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  smacc2_msgs__msg__SmaccState * data = NULL;

  if (size) {
    data = (smacc2_msgs__msg__SmaccState *)allocator.zero_allocate(size, sizeof(smacc2_msgs__msg__SmaccState), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = smacc2_msgs__msg__SmaccState__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        smacc2_msgs__msg__SmaccState__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
smacc2_msgs__msg__SmaccState__Sequence__fini(smacc2_msgs__msg__SmaccState__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      smacc2_msgs__msg__SmaccState__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

smacc2_msgs__msg__SmaccState__Sequence *
smacc2_msgs__msg__SmaccState__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  smacc2_msgs__msg__SmaccState__Sequence * array = (smacc2_msgs__msg__SmaccState__Sequence *)allocator.allocate(sizeof(smacc2_msgs__msg__SmaccState__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = smacc2_msgs__msg__SmaccState__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
smacc2_msgs__msg__SmaccState__Sequence__destroy(smacc2_msgs__msg__SmaccState__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    smacc2_msgs__msg__SmaccState__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
smacc2_msgs__msg__SmaccState__Sequence__are_equal(const smacc2_msgs__msg__SmaccState__Sequence * lhs, const smacc2_msgs__msg__SmaccState__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!smacc2_msgs__msg__SmaccState__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
smacc2_msgs__msg__SmaccState__Sequence__copy(
  const smacc2_msgs__msg__SmaccState__Sequence * input,
  smacc2_msgs__msg__SmaccState__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(smacc2_msgs__msg__SmaccState);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    smacc2_msgs__msg__SmaccState * data =
      (smacc2_msgs__msg__SmaccState *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!smacc2_msgs__msg__SmaccState__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          smacc2_msgs__msg__SmaccState__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!smacc2_msgs__msg__SmaccState__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
