// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from smacc2_msgs:srv/SmaccGetTransitionHistory.idl
// generated code does not contain a copyright notice

#ifndef SMACC2_MSGS__SRV__DETAIL__SMACC_GET_TRANSITION_HISTORY__TRAITS_HPP_
#define SMACC2_MSGS__SRV__DETAIL__SMACC_GET_TRANSITION_HISTORY__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "smacc2_msgs/srv/detail/smacc_get_transition_history__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace smacc2_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const SmaccGetTransitionHistory_Request & msg,
  std::ostream & out)
{
  (void)msg;
  out << "null";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SmaccGetTransitionHistory_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  (void)msg;
  (void)indentation;
  out << "null\n";
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SmaccGetTransitionHistory_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace smacc2_msgs

namespace rosidl_generator_traits
{

[[deprecated("use smacc2_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const smacc2_msgs::srv::SmaccGetTransitionHistory_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  smacc2_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use smacc2_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const smacc2_msgs::srv::SmaccGetTransitionHistory_Request & msg)
{
  return smacc2_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<smacc2_msgs::srv::SmaccGetTransitionHistory_Request>()
{
  return "smacc2_msgs::srv::SmaccGetTransitionHistory_Request";
}

template<>
inline const char * name<smacc2_msgs::srv::SmaccGetTransitionHistory_Request>()
{
  return "smacc2_msgs/srv/SmaccGetTransitionHistory_Request";
}

template<>
struct has_fixed_size<smacc2_msgs::srv::SmaccGetTransitionHistory_Request>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<smacc2_msgs::srv::SmaccGetTransitionHistory_Request>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<smacc2_msgs::srv::SmaccGetTransitionHistory_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'history'
#include "smacc2_msgs/msg/detail/smacc_transition_log_entry__traits.hpp"

namespace smacc2_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const SmaccGetTransitionHistory_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: history
  {
    if (msg.history.size() == 0) {
      out << "history: []";
    } else {
      out << "history: [";
      size_t pending_items = msg.history.size();
      for (auto item : msg.history) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SmaccGetTransitionHistory_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: history
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.history.size() == 0) {
      out << "history: []\n";
    } else {
      out << "history:\n";
      for (auto item : msg.history) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SmaccGetTransitionHistory_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace smacc2_msgs

namespace rosidl_generator_traits
{

[[deprecated("use smacc2_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const smacc2_msgs::srv::SmaccGetTransitionHistory_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  smacc2_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use smacc2_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const smacc2_msgs::srv::SmaccGetTransitionHistory_Response & msg)
{
  return smacc2_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<smacc2_msgs::srv::SmaccGetTransitionHistory_Response>()
{
  return "smacc2_msgs::srv::SmaccGetTransitionHistory_Response";
}

template<>
inline const char * name<smacc2_msgs::srv::SmaccGetTransitionHistory_Response>()
{
  return "smacc2_msgs/srv/SmaccGetTransitionHistory_Response";
}

template<>
struct has_fixed_size<smacc2_msgs::srv::SmaccGetTransitionHistory_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<smacc2_msgs::srv::SmaccGetTransitionHistory_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<smacc2_msgs::srv::SmaccGetTransitionHistory_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__traits.hpp"

namespace smacc2_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const SmaccGetTransitionHistory_Event & msg,
  std::ostream & out)
{
  out << "{";
  // member: info
  {
    out << "info: ";
    to_flow_style_yaml(msg.info, out);
    out << ", ";
  }

  // member: request
  {
    if (msg.request.size() == 0) {
      out << "request: []";
    } else {
      out << "request: [";
      size_t pending_items = msg.request.size();
      for (auto item : msg.request) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: response
  {
    if (msg.response.size() == 0) {
      out << "response: []";
    } else {
      out << "response: [";
      size_t pending_items = msg.response.size();
      for (auto item : msg.response) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SmaccGetTransitionHistory_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "info:\n";
    to_block_style_yaml(msg.info, out, indentation + 2);
  }

  // member: request
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.request.size() == 0) {
      out << "request: []\n";
    } else {
      out << "request:\n";
      for (auto item : msg.request) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: response
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.response.size() == 0) {
      out << "response: []\n";
    } else {
      out << "response:\n";
      for (auto item : msg.response) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SmaccGetTransitionHistory_Event & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace smacc2_msgs

namespace rosidl_generator_traits
{

[[deprecated("use smacc2_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const smacc2_msgs::srv::SmaccGetTransitionHistory_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  smacc2_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use smacc2_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const smacc2_msgs::srv::SmaccGetTransitionHistory_Event & msg)
{
  return smacc2_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<smacc2_msgs::srv::SmaccGetTransitionHistory_Event>()
{
  return "smacc2_msgs::srv::SmaccGetTransitionHistory_Event";
}

template<>
inline const char * name<smacc2_msgs::srv::SmaccGetTransitionHistory_Event>()
{
  return "smacc2_msgs/srv/SmaccGetTransitionHistory_Event";
}

template<>
struct has_fixed_size<smacc2_msgs::srv::SmaccGetTransitionHistory_Event>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<smacc2_msgs::srv::SmaccGetTransitionHistory_Event>
  : std::integral_constant<bool, has_bounded_size<service_msgs::msg::ServiceEventInfo>::value && has_bounded_size<smacc2_msgs::srv::SmaccGetTransitionHistory_Request>::value && has_bounded_size<smacc2_msgs::srv::SmaccGetTransitionHistory_Response>::value> {};

template<>
struct is_message<smacc2_msgs::srv::SmaccGetTransitionHistory_Event>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<smacc2_msgs::srv::SmaccGetTransitionHistory>()
{
  return "smacc2_msgs::srv::SmaccGetTransitionHistory";
}

template<>
inline const char * name<smacc2_msgs::srv::SmaccGetTransitionHistory>()
{
  return "smacc2_msgs/srv/SmaccGetTransitionHistory";
}

template<>
struct has_fixed_size<smacc2_msgs::srv::SmaccGetTransitionHistory>
  : std::integral_constant<
    bool,
    has_fixed_size<smacc2_msgs::srv::SmaccGetTransitionHistory_Request>::value &&
    has_fixed_size<smacc2_msgs::srv::SmaccGetTransitionHistory_Response>::value
  >
{
};

template<>
struct has_bounded_size<smacc2_msgs::srv::SmaccGetTransitionHistory>
  : std::integral_constant<
    bool,
    has_bounded_size<smacc2_msgs::srv::SmaccGetTransitionHistory_Request>::value &&
    has_bounded_size<smacc2_msgs::srv::SmaccGetTransitionHistory_Response>::value
  >
{
};

template<>
struct is_service<smacc2_msgs::srv::SmaccGetTransitionHistory>
  : std::true_type
{
};

template<>
struct is_service_request<smacc2_msgs::srv::SmaccGetTransitionHistory_Request>
  : std::true_type
{
};

template<>
struct is_service_response<smacc2_msgs::srv::SmaccGetTransitionHistory_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // SMACC2_MSGS__SRV__DETAIL__SMACC_GET_TRANSITION_HISTORY__TRAITS_HPP_
